package cds.aida.w1;
import java.awt.*;
import java.awt.event.*;
import java.io.File;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JTextField;



public class Fenetre extends JPanel 
 	implements ItemListener,MouseListener, ActionListener {

	// dfinition des composants
	private JSplitPane spane;
	JScrollPane panasc;
	JButton Ok;
	JPanel pc,pl,ps;
	Label l,l1;
	Label[] labFile;
	Choice ch = new Choice();
	int pos,posf;
	String chemin = "",fichier = "",ftmp = "";
	JFrame fex;
	JTextField input;
	
	private JMenuBar menu;
	
	public Fenetre(JFrame fex,JTextField input) {
		this.input = input;
		this.fex = fex;
		String path;
		Ok = new JButton("Valider");
		l = new Label ("");
		l1 = new Label ("");
		pl = new JPanel();
		pc = new JPanel();
		ps = new JPanel();
		spane=new JSplitPane();
		
		// construction de la liste droulante
		String[] liste;
		GestionFichier gf = new GestionFichier();
		liste = gf.listRoot();
		if(liste.length == 1){
			l.setText(liste[0]);
			setChem(liste[0]);
			path = getChem();
			changePrintFile(path);
			changeCh(path);			
		}else{
			//ch.add("Choisissez un rpertoire");
			for(int i=0;i<liste.length;i++){
				ch.add(liste[i]);
			}
		}
	 
		
	 
		// pose des couteurs d'items la liste 
		ch.addItemListener(this);
		Ok.addActionListener(this);
		
		// composition

		panasc = new JScrollPane(pc);
		
		ch.setSize(100,25);
		pc.setBackground(Color.white);
		GridLayout gd = new GridLayout(19, 1);
		pc.setLayout(gd);
		ps.setLayout(new BorderLayout());
		ps.add(Ok, BorderLayout.EAST);
		pl.add(ch);
		pc.add(l1);
		spane.add(pl,JSplitPane.LEFT);
		spane.add(panasc,JSplitPane.RIGHT);
		spane.setDividerLocation(200);

		this.setLayout(new BorderLayout());

		//this.add(pl,BorderLayout.WEST);
		this.add(l, BorderLayout.NORTH);
		this.add(spane, BorderLayout.CENTER);
		this.add(ps,BorderLayout.SOUTH);
	}
	
	/** redfinition des mthodes appeles lors de la dtection d'un vnement 
	* du genre action provoqu par clic de bouton ou 
	* du genre slection d'item provenant soit de la liste, soit d'un bouton radio */

	public void itemStateChanged (ItemEvent evt) {
		String path;
		// obj est l'objet qui a reu evt, de type slection d'un item
		Object obj = evt.getSource();
		/** on rcupre l'item slectionn avec la mthode getItem() qui interroge l'vnement
		 * et on "cast" pour obtenir le rsultat sous forme de chaine.*/
		String s = (String) (evt.getItem());
		setChem(s);
		path = getChem();
		changePrintPath( path );
		changePrintFile(path);
		changeCh(path);
	}
	
	public void mouseClicked(MouseEvent e){
		l1 = (Label)e.getSource();
		ftmp = l1.getText();
		
		l.setText(getChem()+ftmp);
		l.repaint();
	}
	
	public void actionPerformed(ActionEvent e) {
		// TODO Auto-generated method stub
		setFile();
		input.setText(fichier);
		//setio(getChem()+ftmp);
		fex.setVisible(false);
	}
	
	public String getFile(){
		return fichier;
	}
	
	public void setFile(){
		fichier = getChem()+ftmp;
	}
	
	public void changePrintPath(String str) {
			l.setText(str);
			l.repaint();
	}
	
	public void changePrintFile(String str) {
		pc.removeAll();
		pc.setLayout(new GridLayout(19, 1));
		String[] listF;
		GestionFichier gf = new GestionFichier();
		listF = gf.listFile(str);
		labFile = new Label[listF.length];
		for(int i=0;i<listF.length;i++){
			labFile[i] = new Label(listF[i]);
			pc.add(labFile[i]);			
			labFile[i].addMouseListener(this);
			//new Label(listF[i]).addMouseListener(this);
		}
	}
	
	public String getChem(){
		return chemin;
	}
	
	public void setChem(String chem){
		int lg,pls;
		String tmp;
		if(chem.equals(".."+File.separatorChar)){
			lg = chemin.length();
			lg = lg-1;
			tmp = chemin.substring(0, lg);
			pls = tmp.lastIndexOf(File.separatorChar);
			pls++;
			chemin = chemin.substring(0, pls);
		}else{
			chemin = chemin+chem;
		}
	}
	
	public void changeCh(String s) {
		String[] liste;
		
		//menu bar
		menu=new JMenuBar();
		menu.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));

		// File menu
		JMenu filemenu=new JMenu("File"); //$NON-NLS-1$ //$NON-NLS-2$
		filemenu.setMnemonic('F');
		filemenu.add(new JMenuItem("Quit"));
		menu.add(filemenu);
		
		GestionFichier gf = new GestionFichier();
		liste = gf.listFold(s);
		ch.removeAll(); 
		
		if(getChem().length()>1){
			//ch.add("Choisissez un rpertoire");
			ch.add(".."+File.separatorChar);
		}
		// construction de la liste droulante
		for(int i=0;i<liste.length;i++){
			ch.add(liste[i]);
		}
		 
		//	 pose des couteurs d'items la liste 
		//ch.addItemListener(this);
		 
		// on place la liste et la liste sur le panneau du bas pb

		// composition

		ch.setSize(100,25);
		pl.add(ch);
		pc.add(l1);
		panasc = new JScrollPane(pc); 
		spane.add(pl,JSplitPane.LEFT);
		spane.add(panasc,JSplitPane.RIGHT);
		spane.setDividerLocation(200);

		this.setLayout(new BorderLayout());

		//this.add(pl,BorderLayout.WEST);
		this.add(l, BorderLayout.NORTH);
		this.add(spane, BorderLayout.CENTER);
	}

	public void mouseEntered(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}

	public void mouseExited(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}

	public void mousePressed(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}

	public void mouseReleased(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}



}