/**
 * 
 */
package cds.aida.wsJlow;

import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.GradientPaint;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.util.Hashtable;

import javax.swing.AbstractAction;
import javax.swing.Icon;

import org.jgraph.graph.DefaultGraphCell;
import org.jgraph.graph.PortView;

import cds.jlow.client.codec.action.LoadAsAction;
import cds.jlow.client.descriptor.Attributs;
import cds.jlow.client.descriptor.IRegisterer;
import cds.jlow.client.descriptor.Registerer;
import cds.jlow.client.graph.DefaultMPopupMenu;
import cds.jlow.client.graph.IManagerPopupMenu;
import cds.jlow.client.graph.Jlow;
import cds.jlow.client.graph.cell.PortCell;
import cds.jlow.client.net.service.TaskListService;
import cds.jlow.client.net.socket.SocketProtocol;
import cds.jlow.client.util.ToHtmlModule;
import cds.jlow.client.util.ToStringModule;
import cds.jlow.descriptor.Constant;
import cds.jlow.descriptor.GroupDescriptor;
import cds.jlow.descriptor.IDescriptor;
import cds.jlow.descriptor.IntegerDescriptor;
import cds.jlow.descriptor.PortDescriptor;
import cds.jlow.descriptor.Variable;
import cds.jlow.util.Type;
import cds.jlow.util.Utils;

/**
 * 
 * @author Cyril Pestel
 * @date 6 janv. 2007
 * @version 
 */
public class AddNum extends AbstractAction {
    
    /**
     * 
     */
    public AddNum(Jlow jlow) {
        super("Get tasks");

        putValue(NAME,"Add Numeric");
        putValue("graph",jlow);
        

    }



    
    /* (non-Javadoc)
     * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
     */
    public void actionPerformed(ActionEvent arg0) {
        Jlow graph = (Jlow) getValue("graph");
        int xp,yp;
        graph.getMousePosition();
        IRegisterer reg = graph.getRegister();
        if(graph==null)
            return; //No graph selected


        Hashtable mods = new Hashtable();
        mods.put("tostring", new ToStringModule());
        mods.put("tohtml", new ToHtmlModule());
        
        

        
        Attributs dataatts = reg.getAtt("java.data");
        
		Attributs dataDatts = (Attributs) dataatts.clone();
        
		dataDatts.setId(dataatts.getId()+"numeric:int");
		dataDatts.setName(dataatts.getName()+"numeric:int");
		dataDatts.setBGColor(new Color(255,255,102));
		
		String id = Utils.getIdUnique();
		Type type = new Type("numeric:int");
		Constant cst = new Constant(id,type,null,mods);
		reg.add(cst, dataDatts);
		
		
		Point p = graph.getMousePosition();
        
        if (p.x>100){
        	xp = p.x-100;
        }else{
        	xp = p.x;
        }
        if(p.y>25){
        	yp = p.y-25;
        }else{
        	yp = p.y;
        }
        graph.insertData(new Point(xp,yp), id);
    }

}
