package cds.aida.wsJlow;
/* $Id: DefaultToolView.java,v 1.4 2007/06/06 12:24:19 beugnot Exp $ */
import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Rectangle;
import java.util.Observable;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.Scrollable;
import javax.swing.border.BevelBorder;
import javax.swing.border.Border;
import javax.swing.border.TitledBorder;

import cds.aida.gui.L10N;
import cds.aida.gui.Logger;
import cds.aida.gui.ToolW1View;
import cds.aida.tool.Tool;
import cds.aida.tool.ToolPort;
import cds.aida.w1.ToolCallStatus;
import cds.aida.w1.ToolPortViewDummy;
import cds.aida.w1.ToolPortViewFiles;
import cds.aida.w1.ToolPortViewString;
import cds.aida.w1.ToolView;
import cds.jlow.descriptor.Constant;
import cds.jlow.descriptor.IDescriptor;
import cds.jlow.descriptor.IPortDescriptor;
import cds.jlow.descriptor.PortDescriptor;
import cds.jlow.util.DescriptorFactory;
import cds.jlow.util.Type;

/**
 * GUI for a given tool
 */
public class DefaultDataView extends ToolView implements Scrollable {
	// Tool t; inherited from ToolView
	String callstatus_prefix;
	//
	JPanel header;
	JTextArea comment;
	JLabel callstatus;
	Box ins,outs;
	ToolW1View viewstderr,viewstdout;
	//ToolIOView viewstderr,viewstdout;
	private Border compborder=BorderFactory.createEmptyBorder(10,10,10,10);

	public DefaultDataView(Tool t) {
		this.t=t;
		this.setLayout(new BorderLayout());
		t.addObserver(this);
		setAutoscrolls(true);
	}
	

	public static ToolW1View createIOUI(Constant c) {
		ToolW1View tv=null;
		// XXX dont like 'instanceof' but dbldispatching pb
/*		if(c==null){
			tv=new ToolPortViewDummy(c);
		}else{
			String t1 = c.getType().getName();
			String t = t1.toLowerCase();
		
			if(t.startsWith("string")) {
				tv=new ToolPortViewString(c);
			}
			else if(t.startsWith("numeric")) {
				tv=new ToolPortViewString(c);
			}
			else if(t.startsWith("data")||t.startsWith("fits")||t.startsWith("image")) {
				tv=new ToolPortViewFiles(c);
			}
			else if(t.startsWith("bool")) {
				tv=new ToolPortViewString(c);
			}
		}*/
		
		return tv;
	}
	
	public Dimension getPreferredScrollableViewportSize() {
		// XXX chk if this value is the best we can give.
		return getPreferredSize();
	}
	public int getScrollableBlockIncrement(
			Rectangle visibleRect,
			int orientation,
			int direction) {
		// TODO Auto-generated method stub
		return 0;
	}
	public boolean getScrollableTracksViewportHeight() {
		return false;
	}
	public boolean getScrollableTracksViewportWidth() {
		return true;
	}
	public int getScrollableUnitIncrement(
			Rectangle visibleRect,
			int orientation,
			int direction) {
		// TODO Auto-generated method stub
		return 0;
	}
}
