/**
 * 
 */
package cds.aida.wsJlow;

import java.awt.BorderLayout;
import java.awt.ComponentOrientation;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.geom.Point2D;

import javax.swing.AbstractAction;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JScrollPane;
import javax.swing.JToolBar;

import org.jgraph.graph.DefaultGraphCell;


import cds.aida.gui.Conf;
import cds.aida.gui.L10N;
import cds.aida.gui.Logger;
import cds.aida.gui.ToolW1View;
import cds.aida.gui.WS1View.*;
import cds.aida.tool.Tool;
import cds.aida.tool.ToolPort;
import cds.aida.w1.DefaultToolView;
import cds.aida.w1.ToolView;
import cds.aida.w1.ToolViewFactory;
import cds.jlow.client.descriptor.IRegisterer;
import cds.jlow.client.descriptor.Registerer;
import cds.jlow.client.graph.Jlow;
import cds.jlow.descriptor.Constant;
import cds.jlow.descriptor.IDescriptor;
import cds.jlow.descriptor.Register;
import cds.jlow.descriptor.TaskDescriptor;

/**
 * 
 * @author Cyril Pestel
 * @date 6 janv. 2007
 * @version 
 */

    
public class PropAction extends AbstractAction {
	private Jlow g;
	public PropAction(Jlow g) {
        super("Get tasks");

        putValue(NAME,"Properties");
        putValue("graph",g);
        this.g = g;
	}
	public void actionPerformed(ActionEvent e) {

		Point point=(Point) g.getMarqueeHandler().getCurrentPoint();
		
		Point pcell=new Point();
		pcell.setLocation(point.getX(), point.getY());
		
		Object cell=g.getNextCell(point);
		
		DefaultGraphCell dgc=(DefaultGraphCell)cell;
		Tool t=(Tool)g.getIDescriptor(dgc);
		
		System.out.println("id prop"+t.getID());
		//Tool t = (Tool)reg.getDescriptor(td.getID());
		
		L10N lion=L10N.getInstance();
		String datatitle=lion.get("dialog.data.name","Data parameters"); //$NON-NLS-1$ //$NON-NLS-2$
		final JFrame f=new JFrame(datatitle);
		f.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		Container fc=f.getContentPane();
		fc.setLayout(new BorderLayout());
		
		JScrollPane sp=scrollableToolInterface(t);
		//JToolBar tb=actionsToolBar();
//		this.add(tb,BorderLayout.NORTH);
		fc.add(sp,BorderLayout.CENTER);
		Conf.getInstance().getGraphicRoot().updateUI();
		
		f.setMinimumSize(new Dimension(700,700));
		f.setPreferredSize(new Dimension(700,f.getPreferredSize().height));

		f.pack();
		f.setLocation(g.getX(),g.getY());
		f.setVisible(true);
		/*
		Point2D point=g.getMarqueeHandler().getCurrentPoint();
		Point pcell=new Point();
		pcell.setLocation(point.getX(), point.getY());
		System.out.println("X : "+point.getX());
		Object cell=g.getNextCell(pcell);
		DefaultGraphCell dgc=(DefaultGraphCell)cell;

		TaskDescriptor data=(TaskDescriptor)g.getIDescriptor(dgc);
		
		
		
		Logger.getInstance().log(
				Logger.TRACE,
				"WSWFView.ActionDataDialog("+ //$NON-NLS-1$
				data.getClass()+")"); //$NON-NLS-1$
		L10N lion=L10N.getInstance();
		if(data instanceof ToolPort) {
			showDataDialog((ToolPort)data);
		}
		else {
			String datatitle=lion.get("dialog.data.name","Data parameters"); //$NON-NLS-1$ //$NON-NLS-2$
			JOptionPane.showMessageDialog(
					null,
					lion.get(
							"dialog.data.unavailable", //$NON-NLS-1$
							"Data dialog for this data unavailable"), //$NON-NLS-1$
					datatitle,
					JOptionPane.INFORMATION_MESSAGE);
		}*/
	}
	private void showDataDialog(ToolPort d) {
		ToolW1View tiov=DefaultToolView.createIOUI(d);

		L10N lion=L10N.getInstance();
		String datatitle=lion.get("dialog.data.name","Data parameters"); //$NON-NLS-1$ //$NON-NLS-2$
		final JFrame f=new JFrame(datatitle);
		f.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		Container fc=f.getContentPane();
		fc.setLayout(new BorderLayout());
		
		// scrollable ToolIOView
		JScrollPane scroll=new JScrollPane(tiov);
		fc.add(scroll,BorderLayout.CENTER);
		
		// dismiss button
		String dismiss=lion.get("menu.dismiss","Close"); //$NON-NLS-1$ //$NON-NLS-2$
		JButton jb=new JButton(dismiss);
		jb.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae) {
				f.dispose();
			}
		});
		JToolBar tb=new JToolBar();
		tb.setComponentOrientation(ComponentOrientation.RIGHT_TO_LEFT);
		tb.setFloatable(false);
		tb.add(jb);
		fc.add(tb,BorderLayout.SOUTH);
		
		// dialog size adjustement
		f.pack();
	/*	Dimension dim;
		dim=null;
		double sx=dim.getWidth();
		double sy=dim.getHeight();
		dim=f.getSize();
		double dx=dim.getWidth();
		double dy=dim.getHeight();
		dim.setSize((sx>dx?sx:dx)+10, (sy>dy?sy:dy)+10); 
		f.setSize(dim);*/
		f.setLocation(g.getX(),g.getY());
		f.setVisible(true);
	}
	/**
	 * wrap the toolInterface in a scrollable pane
	 * @return GUI
	 */
	protected JScrollPane scrollableToolInterface(Tool t) {
		ToolViewWS tv = ToolViewFactoryWS.create(t,g);
		JScrollPane sp=new JScrollPane(tv);
		// sets mouse wheel scroll speed
		sp.getVerticalScrollBar().setUnitIncrement(10);
		// starts on top of pane
		sp.getVerticalScrollBar().setValue(0);
		return sp;
	}
}
  

