/**
 * 
 */
package cds.aida.wsJlow;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.Icon;

import cds.jlow.client.graph.Jlow;
import cds.jlow.client.net.service.TaskListService;
import cds.jlow.client.net.socket.SocketProtocol;

/**
 * 
 * @author Cyril Pestel
 * @date 6 janv. 2007
 * @version 
 */
public class TaskListAction extends AbstractAction {

    protected String host;
    protected int port;
    
    /**
     * 
     */
    public TaskListAction(Jlow jlow) {
        super("Get tasks");

        putValue(NAME,"Get tasks");
        putValue("graph",jlow);
        
        host = "127.0.0.1";
        port = 2123;
    }


    public String getHost() {
        return host;
    }

    public void setHost(String host) {
        this.host = host;
    }

    public int getPort() {
        return port;
    }

    public void setPort(int port) {
        this.port = port;
    }
    
    /* (non-Javadoc)
     * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
     */
    public void actionPerformed(ActionEvent arg0) {
        Jlow graph = (Jlow) getValue("graph");
        
        if(graph==null)
            return; //No graph selected

        TaskListService service = new TaskListService(graph,
                    new SocketProtocol(), host, port);
        service.execute("list\n");
    }

}
