package cds.aida.wsJlow;

//import cds.jlow.codec.*;

import cds.jlow.client.graph.*;
//import cds.jlow.client.descriptor.*;
//import cds.jlow.client.sample.service.*;
import cds.jlow.client.net.socket.*;
import cds.jlow.client.net.service.*;

import javax.swing.*;
//import java.io.*;
import java.awt.event.*;

/**
 * This action provide a way of execute the Workflow. It use an ITaskService for
 * sending the graph to the server, and GXLOut for encoding the graph.
 * <p>
 * AATaskService is use.
 * </p>
 * 
 * @see javax.swing.AbstractAction
 * @author Cyril Pestel
 */
public class ExecServAction extends AbstractAction {

	/**
	 * Create an action for executing the Workflow.
	 * 
	 * @param g
	 *            the graph where you draw
	 */
	public ExecServAction(Jlow g) {
		// super("execserv");

		putValue(NAME, "Execute");
		putValue(MNEMONIC_KEY, new Integer(KeyEvent.VK_E));
		putValue("graph", g);
	}

	/**
	 * Invoked when an action occurs.
	 * 
	 * @param e
	 *            an action event
	 */
	public void actionPerformed(ActionEvent e) {
		Jlow graph = (Jlow) getValue("graph");
		// String filename = (String) getValue("filename");
		// IExecuterService = (IExecuterService) getValue("manager");

		// IExecuterService service = new AAExecuterService(graph);
		DefaultService service = new DefaultService(graph,
				new SocketConnexion(),"130.79.129.182",2121);

		// System.out.println("filename : "+filename);
		// filename = "addition.xml";

		if (graph == null || service == null)
			return; // Pas de graph selectionne

		// System.out.println("execute service");
		if (!service.execute())
			System.err.println("No service available");

		/*
		 * String gxl = GXLOut.encode(graph); //System.out.println("GXL :
		 * "+gxl);
		 * 
		 *  // try { //if(manager.execute(gxl)) // ((Thread) manager).start();
		 * service.execute(); // } //catch( IOException ioe) {
		 * System.err.println(ioe); }
		 */
	}

}
